IMPLEMENTATION MODULE RandomData;

        (********************************************************)
        (*                                                      *)
        (*                Generating random data                *)
        (*                                                      *)
        (*  Good cryptographic security relies in part in       *)
        (*  having a good source of pseudo-random data.  This   *)
        (*  module is a little weak in that respect, but should *)
        (*  be good enough for my present purposes.             *)
        (*                                                      *)
        (*  Programmer:         P. Moylan                       *)
        (*  Started:            25 January 2021                 *)
        (*  Last edited:        30 January 2021                 *)
        (*  Status:             Incomplete                      *)
        (*                                                      *)
        (********************************************************)


FROM SYSTEM IMPORT ADDRESS, LOC, ADR;

FROM RandCard IMPORT
    (* proc *)  Randomize, RandCardinal;

FROM LowLevel IMPORT
    (* proc *)  AddOffset, Copy;

(************************************************************************)

PROCEDURE RandomWords (N: CARDINAL;  VAR (*OUT*) result: ARRAY OF LOC);

    (* Stores N random CARD32 values in result. *)

    VAR p: ADDRESS;  j, val: CARDINAL;

    BEGIN
        p := ADR(result);
        FOR j := 0 TO N-1 DO
            val := RandCardinal();
            Copy (ADR(val), p, 4);
            p := AddOffset (p, 4);
        END (*FOR*);
    END RandomWords;

(************************************************************************)

PROCEDURE RandomBytes (N: CARDINAL;  VAR (*OUT*) result: ARRAY OF LOC);

    (* Stores N random CARD38 values in result. *)

    VAR j, k, val: CARDINAL;  p: ADDRESS;

    BEGIN
        j := N DIV 4;  k := N MOD 4;
        IF j > 0 THEN
            RandomWords (j, result);
        END (*IF*);
        IF k > 0 THEN
            val := RandCardinal();
            p := AddOffset (ADR(result), 4*j);
            Copy (ADR(val), p, k);
        END (*IF*);
    END RandomBytes;

(************************************************************************)
(*                          MODULE INITIALISATION                       *)
(************************************************************************)

BEGIN
    Randomize;
END RandomData.

